diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-ht-network.cc ns-3.38/examples/wireless/wifi-ht-network.cc
--- ns-3.37/examples/wireless/wifi-ht-network.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-ht-network.cc	2023-03-16 20:54:23.572868300 -0700
@@ -23,6 +23,7 @@
 #include "ns3/config.h"
 #include "ns3/double.h"
 #include "ns3/enum.h"
+#include "ns3/ht-phy.h"
 #include "ns3/internet-stack-helper.h"
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/ipv4-global-routing-helper.h"
@@ -144,14 +145,17 @@
 
                 WifiMacHelper mac;
                 WifiHelper wifi;
+                std::ostringstream ossControlMode;
 
                 if (frequency == 5.0)
                 {
+                    ossControlMode << "OfdmRate";
                     wifi.SetStandard(WIFI_STANDARD_80211n);
                 }
                 else if (frequency == 2.4)
                 {
                     wifi.SetStandard(WIFI_STANDARD_80211n);
+                    ossControlMode << "ErpOfdmRate";
                     Config::SetDefault("ns3::LogDistancePropagationLossModel::ReferenceLoss",
                                        DoubleValue(40.046));
                 }
@@ -161,13 +165,16 @@
                     return 0;
                 }
 
-                std::ostringstream oss;
-                oss << "HtMcs" << mcs;
+                auto nonHtRefRateMbps = HtPhy::GetNonHtReferenceRate(mcs) / 1e6;
+                ossControlMode << nonHtRefRateMbps << "Mbps";
+
+                std::ostringstream ossDataMode;
+                ossDataMode << "HtMcs" << mcs;
                 wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
                                              "DataMode",
-                                             StringValue(oss.str()),
+                                             StringValue(ossDataMode.str()),
                                              "ControlMode",
-                                             StringValue(oss.str()));
+                                             StringValue(ossControlMode.str()));
                 // Set guard interval
                 wifi.ConfigHtOptions("ShortGuardIntervalSupported", BooleanValue(sgi));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-multirate.cc ns-3.38/examples/wireless/wifi-multirate.cc
--- ns-3.37/examples/wireless/wifi-multirate.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-multirate.cc	2023-03-16 20:54:23.572868300 -0700
@@ -114,7 +114,7 @@
      *
      * \return true if routing is enabled.
      */
-    bool IsRouting()
+    bool IsRouting() const
     {
         return (m_enableRouting == 1) ? 1 : 0;
     }
@@ -124,7 +124,7 @@
      *
      * \return true if mobility is enabled.
      */
-    bool IsMobility()
+    bool IsMobility() const
     {
         return (m_enableMobility == 1) ? 1 : 0;
     }
@@ -134,7 +134,7 @@
      *
      * \return the scenario number.
      */
-    uint32_t GetScenario()
+    uint32_t GetScenario() const
     {
         return m_scenario;
     }
@@ -144,7 +144,7 @@
      *
      * \return the RTS Threshold.
      */
-    std::string GetRtsThreshold()
+    std::string GetRtsThreshold() const
     {
         return m_rtsThreshold;
     }
@@ -154,7 +154,7 @@
      *
      * \return the Output File Name.
      */
-    std::string GetOutputFileName()
+    std::string GetOutputFileName() const
     {
         return m_outputFileName;
     }
@@ -164,7 +164,7 @@
      *
      * \return the Rate Manager.
      */
-    std::string GetRateManager()
+    std::string GetRateManager() const
     {
         return m_rateManager;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-ofdm-eht-validation.cc ns-3.38/examples/wireless/wifi-ofdm-eht-validation.cc
--- ns-3.37/examples/wireless/wifi-ofdm-eht-validation.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-ofdm-eht-validation.cc	2023-03-16 20:54:23.572868300 -0700
@@ -124,25 +124,30 @@
     std::stringstream plotExtra;
     plotExtra << "set xrange [-5:55]\n\
 set yrange [0:1]\n";
-    uint8_t lineNumber = 1;
-    const std::string colors[14] = {"green",
-                                    "blue",
-                                    "red",
-                                    "black",
-                                    "orange",
-                                    "purple",
-                                    "yellow",
-                                    "pink",
-                                    "grey",
-                                    "magenta",
-                                    "brown",
-                                    "turquoise",
-                                    "olive",
-                                    "beige"};
-    for (uint32_t i = 0; i < modes.size(); i++)
+
+    const std::vector<std::string> colors{
+        "green",
+        "blue",
+        "red",
+        "black",
+        "orange",
+        "purple",
+        "yellow",
+        "pink",
+        "grey",
+        "magenta",
+        "brown",
+        "turquoise",
+        "olive",
+        "beige",
+    };
+
+    NS_ASSERT_MSG(colors.size() == modes.size(), "Colors and modes vectors have different sizes");
+
+    for (std::size_t i = 0; i < modes.size(); i++)
     {
-        plotExtra << "set style line " << +lineNumber++ << " linewidth 5 linecolor rgb \""
-                  << colors[i] << "\" \n";
+        plotExtra << "set style line " << (i + 1) << " linewidth 5 linecolor rgb \"" << colors[i]
+                  << "\" \n";
     }
     plotExtra << "set style increment user";
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-power-adaptation-interference.cc ns-3.38/examples/wireless/wifi-power-adaptation-interference.cc
--- ns-3.37/examples/wireless/wifi-power-adaptation-interference.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-power-adaptation-interference.cc	2023-03-16 20:54:23.572868300 -0700
@@ -189,7 +189,7 @@
      *
      * \return the busy time.
      */
-    double GetBusyTime();
+    double GetBusyTime() const;
 
   private:
     /// Time, DataRate pair vector.
@@ -416,7 +416,7 @@
 }
 
 double
-NodeStatistics::GetBusyTime()
+NodeStatistics::GetBusyTime() const
 {
     return m_totalBusyTime + m_totalRxTime;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-simple-adhoc.cc ns-3.38/examples/wireless/wifi-simple-adhoc.cc
--- ns-3.37/examples/wireless/wifi-simple-adhoc.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-simple-adhoc.cc	2023-03-16 20:54:23.572868300 -0700
@@ -137,7 +137,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents(); // Turn on all Wifi logging
+        WifiHelper::EnableLogComponents(); // Turn on all Wifi logging
     }
     wifi.SetStandard(WIFI_STANDARD_80211b);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-simple-adhoc-grid.cc ns-3.38/examples/wireless/wifi-simple-adhoc-grid.cc
--- ns-3.37/examples/wireless/wifi-simple-adhoc-grid.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-simple-adhoc-grid.cc	2023-03-16 20:54:23.572868300 -0700
@@ -31,7 +31,7 @@
 // n0   n1   n2   n3   n4
 //
 // the layout is affected by the parameters given to GridPositionAllocator;
-// by default, GridWidth is 5 and numNodes is 25..
+// by default, GridWidth is 5 (nodes per row) and numNodes is 25..
 //
 // There are a number of command-line options available to control
 // the default behavior.  The list of available command-line options
@@ -43,12 +43,26 @@
 //
 // For instance, for this configuration, the physical layer will
 // stop successfully receiving packets when distance increases beyond
-// the default of 500m.
-// To see this effect, try running:
+// the default of 100m.  The cutoff is around 116m; below that value, the
+// received signal strength falls below the (default) RSSI limit of -82 dBm
+// used by Wi-Fi's threshold preamble detection running.
 //
-// ./ns3 run "wifi-simple-adhoc-grid --distance=500"
-// ./ns3 run "wifi-simple-adhoc-grid --distance=1000"
-// ./ns3 run "wifi-simple-adhoc-grid --distance=1500"
+// To see this effect, try running at a larger distance, and no packet
+// reception will be reported:
+//
+// ./ns3 run "wifi-simple-adhoc-grid --distance=200"
+//
+// The default path through the topology will follow the following node
+// numbers:  24->23->18->13->12->11->10->5->0
+//
+// To see this, the following Bash commands will list the UDP packet
+// transmissions hop-by-hop, if tracing is enabled:
+//
+// ./ns3 run "wifi-simple-adhoc-grid --tracing=1"
+// grep ^t wifi-simple-adhoc-grid.tr  | grep Udp | grep -v olsr | less
+//
+// By changing the distance to a smaller value, more nodes can be reached
+// by each transmission, and the number of forwarding hops will decrease.
 //
 // The source node and sink node can be changed like this:
 //
@@ -67,6 +81,9 @@
 //
 // tcpdump -r wifi-simple-adhoc-grid-0-0.pcap -nn -tt
 //
+// or you can examine the text-based trace wifi-simple-adhoc-grid.tr with
+// an editor.
+//
 
 #include "ns3/command-line.h"
 #include "ns3/config.h"
@@ -133,7 +150,7 @@
 main(int argc, char* argv[])
 {
     std::string phyMode("DsssRate1Mbps");
-    double distance = 500;      // m
+    double distance = 100;      // m
     uint32_t packetSize = 1000; // bytes
     uint32_t numPackets = 1;
     uint32_t numNodes = 25; // by default, 5x5
@@ -168,7 +185,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents(); // Turn on all Wifi logging
+        WifiHelper::EnableLogComponents(); // Turn on all Wifi logging
     }
 
     YansWifiPhyHelper wifiPhy;
@@ -246,10 +263,10 @@
         // Trace routing tables
         Ptr<OutputStreamWrapper> routingStream =
             Create<OutputStreamWrapper>("wifi-simple-adhoc-grid.routes", std::ios::out);
-        olsr.PrintRoutingTableAllEvery(Seconds(2), routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAllEvery(Seconds(2), routingStream);
         Ptr<OutputStreamWrapper> neighborStream =
             Create<OutputStreamWrapper>("wifi-simple-adhoc-grid.neighbors", std::ios::out);
-        olsr.PrintNeighborCacheAllEvery(Seconds(2), neighborStream);
+        Ipv4RoutingHelper::PrintNeighborCacheAllEvery(Seconds(2), neighborStream);
 
         // To do-- enable an IP-level trace that shows forwarding events only
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-simple-infra.cc ns-3.38/examples/wireless/wifi-simple-infra.cc
--- ns-3.37/examples/wireless/wifi-simple-infra.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-simple-infra.cc	2023-03-16 20:54:23.572868300 -0700
@@ -168,7 +168,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents(); // Turn on all Wifi logging
+        WifiHelper::EnableLogComponents(); // Turn on all Wifi logging
     }
     wifi.SetStandard(WIFI_STANDARD_80211b);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-simple-interference.cc ns-3.38/examples/wireless/wifi-simple-interference.cc
--- ns-3.37/examples/wireless/wifi-simple-interference.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-simple-interference.cc	2023-03-16 20:54:23.572868300 -0700
@@ -198,7 +198,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents(); // Turn on all Wifi logging
+        WifiHelper::EnableLogComponents(); // Turn on all Wifi logging
     }
     wifi.SetStandard(WIFI_STANDARD_80211b);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-sleep.cc ns-3.38/examples/wireless/wifi-sleep.cc
--- ns-3.37/examples/wireless/wifi-sleep.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-sleep.cc	2023-03-16 20:54:23.572868300 -0700
@@ -147,7 +147,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents(); // Turn on all Wifi logging
+        WifiHelper::EnableLogComponents(); // Turn on all Wifi logging
     }
     wifi.SetStandard(WIFI_STANDARD_80211b);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-spatial-reuse.cc ns-3.38/examples/wireless/wifi-spatial-reuse.cc
--- ns-3.37/examples/wireless/wifi-spatial-reuse.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-spatial-reuse.cc	2023-03-16 20:54:23.572868300 -0700
@@ -32,7 +32,7 @@
 //  STA1 and AP1 are in one BSS (with color set to 1), while STA2 and AP2 are in
 //  another BSS (with color set to 2). The distances are configurable (d1 through d3).
 //
-//  STA1 is continously transmitting data to AP1, while STA2 is continuously sending data to AP2.
+//  STA1 is continuously transmitting data to AP1, while STA2 is continuously sending data to AP2.
 //  Each STA has configurable traffic loads (inter packet interval and packet size).
 //  It is also possible to configure TX power per node as well as their CCA-ED tresholds.
 //  OBSS_PD spatial reuse feature can be enabled (default) or disabled, and the OBSS_PD
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-spectrum-per-example.cc ns-3.38/examples/wireless/wifi-spectrum-per-example.cc
--- ns-3.37/examples/wireless/wifi-spectrum-per-example.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-spectrum-per-example.cc	2023-03-16 20:54:23.572868300 -0700
@@ -102,7 +102,7 @@
  * Monitor sniffer Rx trace
  *
  * \param packet The sensed packet.
- * \param channelFreqMhz The channel frequancy [MHz].
+ * \param channelFreqMhz The channel frequency [MHz].
  * \param txVector The Tx vector.
  * \param aMpdu The aMPDU.
  * \param signalNoise The signal and noise dBm.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-spectrum-per-interference.cc ns-3.38/examples/wireless/wifi-spectrum-per-interference.cc
--- ns-3.37/examples/wireless/wifi-spectrum-per-interference.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-spectrum-per-interference.cc	2023-03-16 20:54:23.572868300 -0700
@@ -108,7 +108,7 @@
  * Monitor sniffer Rx trace
  *
  * \param packet The sensed packet.
- * \param channelFreqMhz The channel frequancy [MHz].
+ * \param channelFreqMhz The channel frequency [MHz].
  * \param txVector The Tx vector.
  * \param aMpdu The aMPDU.
  * \param signalNoise The signal and noise dBm.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-tcp.cc ns-3.38/examples/wireless/wifi-tcp.cc
--- ns-3.37/examples/wireless/wifi-tcp.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-tcp.cc	2023-03-16 20:54:23.572868300 -0700
@@ -44,7 +44,7 @@
 #include "ns3/packet-sink.h"
 #include "ns3/ssid.h"
 #include "ns3/string.h"
-#include "ns3/tcp-westwood.h"
+#include "ns3/tcp-westwood-plus.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
 
@@ -56,13 +56,13 @@
 uint64_t lastTotalRx = 0; //!< The value of the last total received bytes
 
 /**
- * Calulate the throughput
+ * Calculate the throughput
  */
 void
 CalculateThroughput()
 {
     Time now = Simulator::Now(); /* Return the simulator's virtual time. */
-    double cur = (sink->GetTotalRx() - lastTotalRx) * (double)8 /
+    double cur = (sink->GetTotalRx() - lastTotalRx) * 8.0 /
                  1e5; /* Convert Application RX Packets to MBits. */
     std::cout << now.GetSeconds() << "s: \t" << cur << " Mbit/s" << std::endl;
     lastTotalRx = sink->GetTotalRx();
@@ -95,21 +95,11 @@
 
     tcpVariant = std::string("ns3::") + tcpVariant;
     // Select TCP variant
-    if (tcpVariant == "ns3::TcpWestwoodPlus")
-    {
-        // TcpWestwoodPlus is not an actual TypeId name; we need TcpWestwood here
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType", TypeIdValue(TcpWestwood::GetTypeId()));
-        // the default protocol type in ns3::TcpWestwood is WESTWOOD
-        Config::SetDefault("ns3::TcpWestwood::ProtocolType", EnumValue(TcpWestwood::WESTWOODPLUS));
-    }
-    else
-    {
-        TypeId tcpTid;
-        NS_ABORT_MSG_UNLESS(TypeId::LookupByNameFailSafe(tcpVariant, &tcpTid),
-                            "TypeId " << tcpVariant << " not found");
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType",
-                           TypeIdValue(TypeId::LookupByName(tcpVariant)));
-    }
+    TypeId tcpTid;
+    NS_ABORT_MSG_UNLESS(TypeId::LookupByNameFailSafe(tcpVariant, &tcpTid),
+                        "TypeId " << tcpVariant << " not found");
+    Config::SetDefault("ns3::TcpL4Protocol::SocketType",
+                       TypeIdValue(TypeId::LookupByName(tcpVariant)));
 
     /* Configure TCP Options */
     Config::SetDefault("ns3::TcpSocket::SegmentSize", UintegerValue(payloadSize));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/wifi-vht-network.cc ns-3.38/examples/wireless/wifi-vht-network.cc
--- ns-3.37/examples/wireless/wifi-vht-network.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/wifi-vht-network.cc	2023-03-16 20:54:23.572868300 -0700
@@ -33,6 +33,7 @@
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
 #include "ns3/uinteger.h"
+#include "ns3/vht-phy.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
 
@@ -148,13 +149,18 @@
                 wifi.SetStandard(WIFI_STANDARD_80211ac);
                 WifiMacHelper mac;
 
-                std::ostringstream oss;
-                oss << "VhtMcs" << mcs;
+                std::ostringstream ossControlMode;
+                auto nonHtRefRateMbps = VhtPhy::GetNonHtReferenceRate(mcs) / 1e6;
+                ossControlMode << "OfdmRate" << nonHtRefRateMbps << "Mbps";
+
+                std::ostringstream ossDataMode;
+                ossDataMode << "VhtMcs" << mcs;
                 wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
                                              "DataMode",
-                                             StringValue(oss.str()),
+                                             StringValue(ossDataMode.str()),
                                              "ControlMode",
-                                             StringValue(oss.str()));
+                                             StringValue(ossControlMode.str()));
+
                 // Set guard interval
                 wifi.ConfigHtOptions("ShortGuardIntervalSupported", BooleanValue(sgi));
 
